/*************************************************************************************
* ShatterFuzz.c
*
* Basic message fuzzing tool
*
* Set hWnd to the target windo
*
* Brett Moore [ brett.moore@security-assessment.com ]
* www.security-assessment.com
*
* Blackhat USA 2004 package
*
*************************************************************************************/

#include <stdio.h> 
#include <windows.h> 
#include <Winuser.h>

void check_Window(long hWnd)
{
	// check to see what happened
	if (!IsWindow(hWnd))
	{
		printf("+ Window closed...\n");
		exit(0);
	}
}
int main(int argc, char *argv[]) 
{ 
	long lResult,hWnd;
	long messagecount;
	long messageStart=0;
	long messageMax = 65535;
	char buffertosend[5000];
	BOOL sendmsg = TRUE;
	BOOL postmsg = TRUE;

	memset(buffertosend,0x0,sizeof(buffertosend));
	memset(buffertosend,0x58,sizeof(buffertosend)-1);	// fill it up

	// Set the message handle here
	
	hWnd = 0x000500BE;
	//messageStart = 0x1;	
	//messageMax = WM_USER;


		
	//postmsg = FALSE;
for (messagecount=messageStart;messagecount<=messageMax;messagecount++)
	{
		if ((messagecount != WM_DESTROY) & (messagecount!=WM_CLOSE) & (messagecount != WM_QUIT) & (messagecount != WM_ENDSESSION) & (messagecount != WM_NCDESTROY))
		{
		
			__try{
			
			if(sendmsg)
			{
				printf("+ Sending message %x to child window..0x%xh [ block 1 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
							
				printf("+ Sending message %x to child window..0x%xh [ block 2 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,1,0);
				check_Window(hWnd);
				
				printf("+ Sending message %x to child window..0x%xh [ block 3 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,0,1);
				check_Window(hWnd);
				
				printf("+ Sending message %x to child window..0x%xh [ block 4 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,1,1);
				check_Window(hWnd);
				
				printf("+ Sending message %x to child window..0x%xh [ block 5 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,1,&buffertosend);
				check_Window(hWnd);
				
				printf("+ Sending message %x to child window..0x%xh [ block 6 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,0,&buffertosend);
				check_Window(hWnd);
				
				printf("+ Sending message %x to child window..0x%xh [ block 7 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,&buffertosend,0);
				check_Window(hWnd);
				
				printf("+ Sending message %x to child window..0x%xh [ block 8 ]\n",messagecount,hWnd);
				lResult = SendMessage((HWND) hWnd,(UINT) messagecount,&buffertosend,1);
				check_Window(hWnd);
			}
			if (postmsg)
			{
				// Now do posts
				printf("+ Posting message %x to child window..0x%xh [ block 1 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
							
				printf("+ Posting message %x to child window..0x%xh [ block 2 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
				
				printf("+ Posting message %x to child window..0x%xh [ block 3 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
				
				printf("+ Posting message %x to child window..0x%xh [ block 4 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
				
				printf("+ Posting message %x to child window..0x%xh [ block 5 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
				
				printf("+ Posting message %x to child window..0x%xh [ block 6 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
				
				printf("+ Posting message %x to child window..0x%xh [ block 7 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
				
				printf("+ Posting message %x to child window..0x%xh [ block 8 ]\n",messagecount,hWnd);
				lResult = PostMessage((HWND) hWnd,(UINT) messagecount,0,0);
				check_Window(hWnd);
			}
			
			}

			__except(GetExceptionCode() !=0 )
			{
				printf("+ Message %x to child window..0x%xh caused local exception\n",messagecount,hWnd);
			}

		}
	}
	
	printf("+ Done...\n");
	return 0;
}
